using System;
using System.IO;
using org.bouncycastle.crypto;
using org.bouncycastle.crypto.engines;
using org.bouncycastle.crypto.parameters;
using org.bouncycastle.util.encoders;
using org.bouncycastle.util.test;

namespace test.crypto
{
	/**
	* cast tester - vectors from http://www.ietf.org/rfc/rfc2144.txt
	*/
	public class CAST5Test: CipherTest
	{
		static Test[]  tests = {
			new BlockCipherVectorTest(0, new CAST5Engine(),
				new KeyParameter(Hex.decode("0123456712345678234567893456789A")),
				"0123456789ABCDEF", 
				"238B4FE5847E44B2"),
			new BlockCipherVectorTest(0, new CAST5Engine(),
				new KeyParameter(Hex.decode("01234567123456782345")),
				"0123456789ABCDEF", 
				"EB6A711A2C02271B"),
			new BlockCipherVectorTest(0, new CAST5Engine(),
				new KeyParameter(Hex.decode("0123456712")),
				"0123456789ABCDEF", 
				"7Ac816d16E9B302E"),
				};

		CAST5Test(): base(tests) {}

		public override String getName()
		{
			return "CAST5";
		}

		[STAThread]
		static void Main(string[] args)
		{
			CAST5Test    	test = new CAST5Test();
			TestResult      result = test.perform();

			Console.WriteLine(result.ToString());
		}
	}
}
