using System;
using System.Text;
//using org.bouncycastle.math;
//using org.bouncycastle.math.ec;
//using org.bouncycastle.security;
using org.bouncycastle.crypto;
//using org.bouncycastle.crypto.signers;
//using org.bouncycastle.crypto.digests;
using org.bouncycastle.crypto.engines;
//using org.bouncycastle.crypto.agreement;
//using org.bouncycastle.crypto.generators;
using org.bouncycastle.crypto.parameters;
//using org.bouncycastle.crypto.macs;
//using org.bouncycastle.crypto.modes;
//using org.bouncycastle.crypto.paddings;
using org.bouncycastle.util.encoders;
using org.bouncycastle.util.test;


namespace test.crypto
{
	/**
	* RC4 Test
	*/
	public class RC4Test: Test
	{
		StreamCipherVectorTest[] tests =
		{
			new StreamCipherVectorTest(0, new RC4Engine(),
					new KeyParameter(Hex.decode("0123456789ABCDEF")),
					"4e6f772069732074", "3afbb5c77938280d"),
			new StreamCipherVectorTest(0, new RC4Engine(),
					new KeyParameter(Hex.decode("0123456789ABCDEF")),
					"68652074696d6520", "1cf1e29379266d59"),
			new StreamCipherVectorTest(0, new RC4Engine(),
					new KeyParameter(Hex.decode("0123456789ABCDEF")),
					"666f7220616c6c20", "12fbb0c771276459")
		};

		public String getName()
		{
			return "RC4";
		}

		public TestResult perform()
		{
			for (int i = 0; i != tests.Length; i++)
			{
				TestResult  res = tests[i].perform();

				if (!res.isSuccessful())
				{
					return res;
				}
			}

			return new SimpleTestResult(true, getName() + ": Okay");
		}

		[STAThread]
		static void Main(string[] args)
		{
			RC4Test test = new RC4Test();
			TestResult  result = test.perform();

			Console.WriteLine(result.ToString());
		}
	}

}
