@ echo off

@ set DEVEL_ROOT=D:\SecLab\BouncyCastleAPI
@ set SRC_ROOT=%DEVEL_ROOT%\src
@ set BIN=%DEVEL_ROOT%\bin
@ set BUILDFLAg = 

@ SET DBG=/debug+
@ IF "%1"=="-r" SET DBG=/debug-
@ IF "%1"=="-R" SET DBG=/debug-

:COMPAT
@ echo compat
@ cd %SRC_ROOT%
@ set SRC_compat=math\BigInteger.cs security\SecureRandom.cs crypto\*.cs io\*.cs crypto\digests\*.cs

csc.exe /nologo %DBG% /target:module /out:%BIN%\compat.netmodule %SRC_compat%

@ cd %SRC_ROOT%\util

csc.exe /nologo %DBG% /target:module /out:%BIN%\util.netmodule encoders\*.cs 


:ECMATH
@ echo ecmath
@ cd %SRC_ROOT%\math\ec

csc.exe /nologo %DBG% /target:module /addmodule:%BIN%\compat.netmodule /out:%BIN%\ecmath.netmodule *.cs


:PARAMETERS
@ echo param
@ cd %SRC_ROOT%\crypto\parameters
@ set AddModules_param=%BIN%\compat.netmodule,%BIN%\ecmath.netmodule

csc.exe /nologo %DBG% /target:module /addmodule:%AddModules_param% /out:%BIN%\param.netmodule *.cs


:ENCODINGS
@ echo encoding
@ cd %SRC_ROOT%\crypto\encodings
@ set AddModules_encodings=%BIN%\compat.netmodule,%BIN%\param.netmodule

csc.exe /nologo %DBG% /target:module /addmodule:%AddModules_encodings% /out:%BIN%\encodings.netmodule *.cs


: PADDINGS
@ echo padding
@ cd %SRC_ROOT%\crypto\paddings
@ set AddModules_paddings=%BIN%\compat.netmodule,%BIN%\param.netmodule

csc.exe /nologo %DBG% /target:module /addmodule:%AddModules_paddings% /out:%BIN%\paddings.netmodule *.cs

:MODES
@ echo modes
@ cd %SRC_ROOT%\crypto\modes
@ set AddModules_modes=%BIN%\compat.netmodule,%BIN%\param.netmodule

csc.exe /nologo %DBG% /target:module /addmodule:%AddModules_modes% /out:%BIN%\modes.netmodule *.cs



:ENGINES
@ echo engines
@ cd %SRC_ROOT%\crypto\engines
@ set AddModules_engines=%BIN%\compat.netmodule,%BIN%\param.netmodule,%BIN%\modes.netmodule

csc.exe /nologo %DBG% /target:module /addmodule:%AddModules_engines% /out:%BIN%\engines.netmodule *.cs


:AGREEMENT
@ echo agreement
@ cd %SRC_ROOT%\crypto\agreement
@ set AddModules_agreement=%BIN%\compat.netmodule,%BIN%\param.netmodule,%BIN%\ecmath.netmodule

csc.exe /nologo %DBG% /target:module /addmodule:%AddModules_agreement% /out:%BIN%\agreement.netmodule *.cs



:MACS
@ echo macs
@ cd %SRC_ROOT%\crypto\macs
@ set AddModules_macs=%BIN%\compat.netmodule,%BIN%\param.netmodule,%BIN%\modes.netmodule,%BIN%\paddings.netmodule

csc.exe /nologo %DBG% /target:module /addmodule:%AddModules_macs% /out:%BIN%\macs.netmodule *.cs


:GENERATORS
@ echo generators
@ cd %SRC_ROOT%\crypto\generators
@ set AddModules_generators=%BIN%\compat.netmodule,%BIN%\param.netmodule,%BIN%\ecmath.netmodule,%BIN%\macs.netmodule

csc.exe /nologo %DBG% /target:module /addmodule:%AddModules_generators% /out:%BIN%\generators.netmodule *.cs


:IO
@ echo io
@ cd %SRC_ROOT%\crypto\io
@ set AddModules_io=%BIN%\compat.netmodule

csc.exe /nologo %DBG% /target:module /addmodule:%AddModules_io% /out:%BIN%\io.netmodule *.cs


:ASN1
@ echo asn1
@ cd %SRC_ROOT%\asn1
@ set AddModules_asn1=%BIN%\compat.netmodule,%BIN%\ecmath.netmodule,%BIN%\util.netmodule

csc.exe /nologo %DBG% /target:module /addmodule:%AddModules_asn1% /out:%BIN%\asn1.netmodule *.cs pkcs\*.cs x509\*.cs x9\*.cs util\*.cs


:SIGNERS
@ echo signers
@ cd %SRC_ROOT%\crypto\signers
@ set AddModules_signers=%BIN%\compat.netmodule,%BIN%\param.netmodule,%BIN%\ecmath.netmodule

csc.exe /nologo %DBG% /target:module /addmodule:%AddModules_signers% /out:%BIN%\signers.netmodule *.cs 


:TESTUTIL
@ echo testutil
@ cd %SRC_ROOT%\util\test
@ set AddModules_testutil=%BIN%\compat.netmodule,%BIN%\param.netmodule,%BIN%\util.netmodule
csc.exe /nologo %DBG% /target:module /addmodule:%AddModules_testutil% /out:%BIN%\testutil.netmodule *.cs 



@ REM generate public and private key pair
cd %BIN%
sn -q /k Keyfile.snk

@ set NETMODULES=compat.netmodule util.netmodule  ecmath.netmodule  param.netmodule encodings.netmodule paddings.netmodule modes.netmodule engines.netmodule agreement.netmodule macs.netmodule generators.netmodule io.netmodule asn1.netmodule signers.netmodule testutil.netmodule

al /nologo /keyfile:keyfile.snk /target:library  /out:bc.dll /version:1.19.0.0 %NETMODULES% 
 
cd %DEVEL_ROOT%
