using System;
using System.IO;
using org.bouncycastle.io;

namespace org.bouncycastle.asn1
{
	public class BEROutputStream: DEROutputStream
	{
		public BEROutputStream(
			Stream    os) : base(os) {}

		public override  void writeObject(Object    obj)
			//throws IOException
		{
			if (obj == null)
			{
				writeNull();
			}
			else if (typeof(DERObject).IsInstanceOfType(obj))
			{
				((DERObject)obj).encode(this);
			}
			else if (typeof(DEREncodable).IsInstanceOfType(obj))
			{
				((DEREncodable)obj).getDERObject().encode(this);
			}
			else
			{
				throw new IOException("object not BEREncodable");
			}
		}
	}

}