using System;
using System.IO;
using System.Collections;
//using org.bouncycastle.io;

namespace org.bouncycastle.asn1
{
	public class BERSequence : DERSequence
	{
		/**
		* create an empty sequence
		*/
		public BERSequence()
		{
		}

		/**
		* create a sequence containing one object
		*/
		public BERSequence(
			DEREncodable    obj) : base(obj) {}

		/**
		* create a sequence containing a vector of objects.
		*/
		public BERSequence(
			DEREncodableVector   v) : base(v) {}

		/*
		*/
		public override  void encode(DEROutputStream outStream)
			//throws IOException
		{
			if (typeof(ASN1OutputStream).IsInstanceOfType(outStream) ||
				typeof(BEROutputStream).IsInstanceOfType(outStream))
			{
				outStream.write(DERTags.SEQUENCE | DERTags.CONSTRUCTED);
				outStream.write(0x80);
	            
				IEnumerator e = getObjects();
				while (e.MoveNext())
				{
					outStream.writeObject(e.Current);
				}
	        
				outStream.write(0x00);
				outStream.write(0x00);
			}
			else
			{
				base.encode(outStream);
			}
		}
	}

}