
using System;
//using System.Collections;
//using org.bouncycastle.io;
using org.bouncycastle.asn1;

namespace org.bouncycastle.asn1.x509
{
	public class AttributeCertificateInfo: DEREncodable
	{
		internal DERInteger              attCertVersion = null;
		internal Holder                  holder = null;
		internal AttCertIssuer           issuer = null;
		internal AlgorithmIdentifier     signature = null;
		internal DERInteger              serialNumber = null;
		internal AttCertValidityPeriod   attrCertValidityPeriod = null;
		internal ASN1Sequence            attributes = null;
		internal DERBitString            issuerUniqueID = null;
		internal X509Extensions          extensions = null;

		public DERInteger getAttCertVersion()
		{
			return attCertVersion;
		}

		public Holder getHolder()
		{
			return holder;
		}

		public AttCertIssuer getIssuer()
		{
			return issuer;
		}

		public AlgorithmIdentifier getSignature()
		{
			return signature;
		}

		public DERInteger getSerialNumber()
		{
			return serialNumber;
		}

		public AttCertValidityPeriod getAttrCertValidityPeriod()
		{
			return attrCertValidityPeriod;
		}

		public ASN1Sequence getAttributes()
		{
			return attributes;
		}

		public DERBitString getIssuerUniqueID()
		{
			return issuerUniqueID;
		}

		public X509Extensions getExtensions()
		{
			return extensions;
		}

		/**
		 * <pre>
		 *  AttributeCertificateInfo ::= SEQUENCE {
		 *       version              AttCertVersion -- version is v2,
		 *       holder               Holder,
		 *       issuer               AttCertIssuer,
		 *       signature            AlgorithmIdentifier,
		 *       serialNumber         CertificateSerialNumber,
		 *       attrCertValidityPeriod   AttCertValidityPeriod,
		 *       attributes           SEQUENCE OF Attribute,
		 *       issuerUniqueID       UniqueIdentifier OPTIONAL,
		 *       extensions           Extensions OPTIONAL
		 *  }
		 *
		 *  AttCertVersion ::= INTEGER { v2(1) }
		 * </pre>
		 */
		public DERObject getDERObject()
		{
			ASN1EncodableVector  v = new ASN1EncodableVector();

			return new DERSequence(v);
		}
	}

}